PLASMA 2.8.0 PLASMA - Parallel Linear Algebra for Scalable Multi-core Architectures

- Main Page
- Modules
- Data Types List

int CORE_sttlqt | ( | int | M,
|  | int | N,
|  | int | IB,
|  | float * | A1,
|  | int | LDA1,
|  | float * | A2,
|  | int | LDA2,
|  | float * | T,
|  | int | LDT,
|  | float * | TAU,
|  | float * | WORK
| ) |  |

CORE_sttlqt computes a LQ factorization of a rectangular matrix formed by coupling side-by-side a complex M-by-M lower triangular tile A1 and a complex M-by-N lower triangular tile A2:

| A1 A2 | = L * Q

The tile Q is represented as a product of elementary reflectors

Q = H(k)' . . . H(2)' H(1)', where k = min(M,N).

Each H(i) has the form

H(i) = I - tau * v * v'

where tau is a complex scalar, and v is a complex vector with v(1:i-1) = 0 and v(i) = 1; g(v(i+1:n)) is stored on exit in A2(i,1:n), and tau in TAU(i).

Parameters

  [in] | M | The number of rows of the tile A1 and A2. M >= 0. The number of columns of the tile A1.
  [in] | N | The number of columns of the tile A2. N >= 0.
  [in] | IB | The inner-blocking size. IB >= 0.
  [in,out] | A1 | On entry, the M-by-M tile A1. On exit, the elements on and below the diagonal of the array contain the M-by-M lower trapezoidal tile L; the elements above the diagonal are not referenced.
  [in] | LDA1 | The leading dimension of the array A1. LDA1 >= max(1,N).
  [in,out] | A2 | On entry, the M-by-N lower triangular tile A2. On exit, the elements on and below the diagonal of the array with the array TAU, represent the unitary tile Q as a product of elementary reflectors (see Further Details).
  [in] | LDA2 | The leading dimension of the array A2. LDA2 >= max(1,M).
  [out] | T | The IB-by-N triangular factor T of the block reflector. T is upper triangular by block (economic storage); The rest of the array is not referenced.
  [in] | LDT | The leading dimension of the array T. LDT >= IB.
  [out] | TAU | The scalar factors of the elementary reflectors (see Further Details).
  [in,out] | WORK |

Returns

Return values

  PLASMA_SUCCESS | successful exit
  <0 | if -i, the i-th argument had an illegal value